#include <stdio.h>
#include <stdlib.h>
#include <string.h>




static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}




static char flag_tbl[256][8];

static void make_flag_tbl(void){
	int k, n, m;
	int c;
	for(n = 0; 256 > n; ++n){
		c = -1;
		flag_tbl[n][0] = -1;
		m = n;
		for(k = 0; 8 > k; ++k){
			if(0 == (m & 1)){
				c += 1;
				flag_tbl[n][c] = 0;
			}
			else{
				if((0 > c)  || (0 == flag_tbl[n][c])){
					c += 1;
					flag_tbl[n][c] = 0;
				}
				flag_tbl[n][c] += 1;
			}
			m >>= 1;
		}
		if(7 > c){
			c += 1;
			flag_tbl[n][c] = -1;
		}
	}
}

static void init_dic(unsigned char *dic){
	int k;
	for(k = 0; 256 > k; ++k){
		memset(dic, k, 0x0d);
		dic += 0x0d;
	}
	k = 0;
	while(256 > k){
		dic[0] = k;
		dic += 1;
		k += 1;
	}
	while(0 < k){
		k -= 1;
		dic[0] = k;
		dic += 1;
	}
	memset(dic, 0, 0x80);
	dic += 0x80;
	memset(dic, 0x20, 0x6e);
	dic += 0x6e;
	memset(dic, 0, 0x12);
}


static int expand(unsigned char *dest, long dest_size, unsigned char *src, long src_size){
	unsigned char dic[4096];
	char *flag;
	int flag_count;
	long ofs, dest_ofs;
	int dic_ofs;


	make_flag_tbl();

	init_dic(dic);


	ofs = 0;
	dest_ofs = 0;
	dic_ofs = (4096 - 18);

	while(ofs < src_size){
		flag = flag_tbl[src[ofs]];
		ofs += 1;
		flag_count = 0;

		for(flag_count = 0; 8 > flag_count; ++flag_count){
			int t_ofs, t_len;

			if(src_size <= ofs){
				break;
			}

			t_len = flag[flag_count];
			if(0 > t_len){
				break;
			}

			if(0 < t_len){
				for(; 0 < t_len; --t_len){
					dest[dest_ofs] = src[ofs];
					dest_ofs += 1;
					dic[dic_ofs] = src[ofs];
					dic_ofs = ((dic_ofs + 1) & 0xFFF);
					ofs += 1;
				}
				continue;
			}

			t_ofs = src[ofs] | ((src[ofs + 1] & 0xF0) << 4);
			t_len = ((src[ofs + 1] & 0x0F) + 3);
			ofs += 2;

			for(; 0 < t_len; --t_len){
				dest[dest_ofs] = dic[t_ofs];
				dest_ofs += 1;
				dic[dic_ofs] = dic[t_ofs];
				t_ofs = ((t_ofs + 1) & 0xFFF);
				dic_ofs = ((dic_ofs + 1) & 0xFFF);
			}

		}
	}

	return dest_ofs;
}






int main(int argc, char *argv[]){
	char *src;
	long src_size;

	if(3 > argc){
		printf("mir_exp.exe [infile] [outfile]\n");
		exit(0);
	}


	{
		FILE *fp;

		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			printf("%s ݂܂\n", argv[1]);
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		src_size = ftell(fp);
		fseek(fp, 0, SEEK_SET);
		src = malloc(src_size);
		if(NULL == src){
			fclose(fp);
			printf("sł\n");
			exit(1);
		}
		fread(src, 1, src_size, fp);
		fclose(fp);
	}


	{
		long t;
		char *buf;
		FILE *fp;

		t = get_dword(src);
		if(src_size != (t + 8)){
			free(src);
			printf("%s ͈kt@Cł͂܂\n", argv[1]);
			exit(1);
		}
		t = get_dword(src + 4);
		if(src_size > t){
			free(src);
			printf("%s ͈kt@Cł͂܂\n", argv[1]);
			exit(1);
		}

		buf = malloc(t);
		if(NULL == buf){
			free(src);
			printf("sł\n");
			exit(1);
		}
		t = expand(buf, t, (src + 8), (src_size - 8));

		fp = fopen(argv[2], "wb");
		fwrite(buf, 1, t, fp);
		fclose(fp);

		free(buf);
	}


	free(src);
	exit(0);
}
